DiscordInviteManager_MyGroup = DiscordInviteManager_MyGroup or {};
DiscordInviteManager_Link = DiscordInviteManager_Link or '';
DiscordInviteManager_ExpirationTime = DiscordInviteManager_ExpirationTime or 0;
DiscordInviteManager_LastWarning = DiscordInviteMangager_LastWarning or 0;
DiscordInviteManager_Active = DiscordInviteManager_Active or true;
DiscordInviteManager_OnEvent = function(self,event,...)
	if(event == "GROUP_ROSTER_UPDATE") then
		if DiscordInviteManager_Active then
			local currentTime = time();
			if currentTime < DiscordInviteManager_ExpirationTime then
				local isRaid = IsInRaid();
				local isGroup = IsInGroup();
				if(isGroup) then
					local size = GetNumGroupMembers();
					local groupType = "party";
					if(isRaid) then groupType = "raid"; end
					local tempGroup = {};
					for i = 1,size do
						name = GetUnitName(groupType..i,true);
						local isInGroup = false;
						tinsert(tempGroup,name);
						for idx,val in ipairs(DiscordInviteManager_MyGroup) do
							if(val == name) then
								isInGroup = true;
							end
						end
						if(not isInGroup and not not name) then
							SendChatMessage(DiscordInviteManager_Link.." - Courtesy of Discord Invite Manager","WHISPER",nil,name);
						end
					end
					DiscordInviteManager_MyGroup = tempGroup;
				else
					DiscordInviteManager_MyGroup = {};
				end
			else
				DiscordInviteManager_PrintWarning();
			end
		end
	end
end

DiscordInviteManager_Toggle = function(state)
	if strupper(state) == "ON" then
		DiscordInviteManager_Active = true;
	elseif strupper(state) == "OFF" then
		DiscordInviteManager_Active = false;
	else
		DiscordInviteManager_Active = not DiscordInviteManager_Active;
	end
	if DiscordInviteManager_Active then print("Discord Invite Manager is now on.");
	else print("Discord Invite Manager is now off.");
	end
	
end
DiscordInviteManager_Activate = function(link,minutes)
	if not link then
		DEFAULT_CHAT_FRAME:AddMessage("DISCORD INVITE MANAGER: You must provide a discord link.");
	else
		local duration = tonumber(mintues) or 63072000;
		DiscordInviteManager_Link = link;
		DiscordInviteManager_ExpirationTime = time() + duration;
		DiscordInviteManager_Active = true;
		print("Discord Invite Link:"..link..".");
	end
end
DiscordInviteManager_PrintWarning = function()
	if time() > (DiscordInviteManager_LastWarning + 60) then 
		DEFAULT_CHAT_FRAME:AddMessage("DISCORD INVITE MANAGER: Your Discord Invite Manager link has expired.  Use /dim <link> [Optional: Minutes until Expires] to add a new link, or /dim toggle to turn DIM on or off.");
		DiscordInviteManager_LastWarning = time();
	end
end
DiscordInviteManager_OnUpdate = function(self,elapsed)
	if time() > DiscordInviteManager_ExpirationTime and DiscordInviteManager_Active then
		DiscordInviteManager_PrintWarning();
	end
end

DiscordInviteManager_Frame = CreateFrame("frame","DiscordInviteManager_FRAME");
DiscordInviteManager_Frame:RegisterEvent("GROUP_ROSTER_UPDATE");
DiscordInviteManager_Frame:SetScript("OnUpdate",DiscordInviteManager_OnUpdate);
DiscordInviteManager_Frame:SetScript("OnEvent",DiscordInviteManager_OnEvent);

SLASH_DISCORDINVITEMANAGER1 = "/dim";
DiscordInviteManager_SlashCommands = function(msg,editbox)
	local cmd = nil;
	local slashArgs = {};
	for val in msg:gmatch("%S+") do
		if not cmd then cmd = strupper(val);
		else
			tinsert(slashArgs,val);
		end
	end
	if cmd == "TOGGLE" then 
		local state = "";
		if not not slashArgs then
			state = slashArgs[1] or "UNSET";
		end
		DiscordInviteManager_Toggle(state);
	elseif strupper(cmd) == "LINK" then
		if not not slashArgs then
			DiscordInviteManager_Activate(slashArgs[1],slashArgs[2]);
		end
	else
		print("Discord Invite Manager Help:");
		print("/dim toggle [on/off] - Turn DIM on or off.");
		print("/dim link <discord link> [Minutes to Live] - Sets the discord link to be provided to new group/raid members and sets the time until the link expires.");
	end
end
SlashCmdList["DISCORDINVITEMANAGER"] = DiscordInviteManager_SlashCommands;

DEFAULT_CHAT_FRAME:AddMessage("DiscordInviteManager Loaded");